#ifndef I_SLEEPABLE_HPP
#define I_SLEEPABLE_HPP

// a little interface for a function to poll classes that they are ready for sleep

class i_sleepable {
public:

	//! \brief asks if class/device/periph can sleep or not
	//! \param[inout] can_sleep internally ANDed boll that a chain can sleep or not
	virtual void can_sleep(bool *can_sleep) = 0;
};

#endif // I_SLEEPABLE_HPP