#include "stdint.h"

// get static contructors out of linkerscript
extern void (*_init_array_start_ []) (void) __attribute__((weak));
extern void (*_init_array_end_ []) (void) __attribute__((weak));

extern "C" void cpp_init_caller(void) {
	
	uint32_t num_of_inits = _init_array_end_ - _init_array_start_;
	uint32_t i;
	
	// call every constructor in this function pointer array
	for (i = 0; i < num_of_inits; i++) {
		_init_array_start_[i]();
	}
}